/**
 * ----------------------------------------------------------------
 * Copyright (C) 2012 dx0ne
 * ----------------------------------------------------------------
 *
 * File:		EnemyManager.as
 * Info:		
 * Package		 
 *
 * @author		dx0ne <dx0ne@laislacorporation.com>
 */
package  
{
	import starling.display.Sprite;

	public class EnemyManager 
	{
		public var view:Sprite;
		
		private var enemies:Vector.<Enemy>;
		private var MAX_ENEMIES:int = 30;
		private var i:int;
		private var tE:Enemy;
		
		public var generationInterval:Number = 0.8;
		private var lastGenerated:Number=-3;
		
		public var skip:Boolean = false;
		
		
		private var patterns:Array = [
			//[0, 1, 0, 1]
			[0, 1, 0, 1],
			[1, 0, 1, 0],

			[0, 1, 1, 0],			
			[1, 0, 0, 1],

			[1, 1, 1, 1],
			[0, 0, 0, 0],
			
			[1, 1, 1, 0],
			[1, 1, 0, 1],
			[1, 0, 1, 1],
			[0, 1, 1, 1],
			
			[0, 0, 0, 1],
			[0, 0, 1, 0],
			[0, 1, 0, 0],
			[1, 0, 0, 0]
		];
		
		private var patternsLength:int = patterns.length;
		
		private var currentPatter:Array = patterns[0];
		private var currentPatterIdx:int = -1;
		private var currentPatterIdxMax:int = currentPatter.length;
		
		public function EnemyManager() 
		{
			view = new Sprite();
			
			enemies = new Vector.<Enemy>;

			for (i = 0; i < MAX_ENEMIES; i++ )
			{
				tE = new Enemy();
				enemies.push(tE);
				view.addChild(tE);
			}
		}
		
		public function update(dt:Number):void
		{
			if (!skip) 
			{
				lastGenerated += dt;
				if (lastGenerated >= generationInterval)
				{
					lastGenerated -= generationInterval;
					generateEnemy();
				}
			}
			var i:int=0;
			for (i = 0; i < MAX_ENEMIES; i++ )
			{
				tE = enemies[i];
				if (!tE.isAlive) continue;
				
				tE.update(dt);
			}
		}
		
		public function collide(side:int=0):Enemy
		{
			var i:int=0;
			for (i = 0; i < MAX_ENEMIES; i++ )
			{
				tE = enemies[i];
				if (!tE.isAlive) continue;
				
				if (tE.isNearPlayer())
				if (tE.side == side || side == 0)
				{
					lastGenerated = -1;
					if (tE.canExplode)
					{
						tE.explode();
						return tE;
					}
				}
			}
			
			return null;
		}
		
		private function generateEnemy():Enemy
		{
			tE = findFreeEnemy();
			if (tE == null) return null;
			
			
			var side:int = getSideFromPattern();
			trace(side)
			if (side == -1) return null;
			
			tE.init();
			if (side == 0)
			{
				tE.leftInit();
			}
			
			return tE;
		}
		
		private function getSideFromPattern():int
		{

			currentPatterIdx++;
			if (currentPatterIdx >= currentPatterIdxMax)
			{
				currentPatter = patterns[(patternsLength * Math.random()) >> 0];
				currentPatterIdxMax = currentPatter.length;
				currentPatterIdx = 0;

				if (Math.random() > 0.75)
				{
					currentPatterIdx = -1;
					return -1;
				}
			}
			
			return currentPatter[currentPatterIdx];
		}
		
		private function findFreeEnemy():Enemy
		{
			var i:int
			for (i = 0; i < MAX_ENEMIES; i++ )
			{
				tE = enemies[i];
				if (tE.isAlive==false) return tE;
			}
			
			return null;
		}
	}

}