/**
 * ----------------------------------------------------------------
 * Copyright (C) 2012 dx0ne
 * ----------------------------------------------------------------
 *
 * File:		Game.as
 * Info:		
 * Package		 
 *
 * @author		dx0ne <dx0ne@laislacorporation.com>
 */
package 
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import starling.display.Image;
	import starling.display.MovieClip;
	import starling.display.Sprite;
	import starling.events.Event;
	import starling.events.EnterFrameEvent;
	import starling.textures.TextureAtlas;
	import starling.core.Starling;
	import starling.display.BlendMode;
	import com.gamua.flox.Flox;
	
	public class Game extends Sprite 
	{
		private var motoGlowSpr:Sprite;
		private var motoGlowImage:Image;
		
		private var citySpr:Sprite;
		
		private var dirtSpr:Sprite;
		private var dirtSpr2:Sprite;
		private var dirtImage:Image;
		private var dirtImage2:Image;
		
		private var vigneL0:Image;
		private var vigneL1:Image;
		private var vigneR0:Image;
		private var vigneR1:Image;
		
		private var roadBarsPM:ParticleManager;
		private var lampsPM:ParticleManager;
		private var enemyManager:EnemyManager;
		
		public static var bd:BitmapData;
		private var bdX:int = 0;;
		private var bdY:int = 0;;
		private var bdX2:int = 0;;
		private var bdY2:int = 0;;
		public static var bdXmax:int = 256;
		
		private var keyOffset:Number=0;
		private var driverOffset:Number=0;
		private var collideForceY:Number=0;
		private var collideForceYMax:Number=1.1;
		
		private var hitLeft:Hit;
		private var hitRight:Hit;
		private var tEnemy:Enemy;
		
		private var paused:Boolean = false;
		private var clicktofocus:Clicktofocus;
		
		public function Game():void 
		{
			Starling.current.addEventListener(Event.ROOT_CREATED, starling_RootCreatedHandler);
		}
		private function starling_RootCreatedHandler(event:Event):void
		{
			Starling.current.removeEventListener(Event.ROOT_CREATED, starling_RootCreatedHandler);

			prepare();
			
			InputModel.prepare(Starling.current.nativeStage);
			//this.scaleX = this.scaleY = 0.5;
			

			
			this.stage.addEventListener(Event.ENTER_FRAME, onEnterFrame);
		}		
		
		private function prepare():void
		{
			this.alpha = 0.999;
			var _ta:TextureAtlas = AssetsGenerator.defaultAtlas = AssetsGenerator.getTextureAtlas();
			
			var city:MovieClip = new MovieClip(_ta.getTextures("city"), 10);
			Starling.juggler.add(city);
			city.x = (640 - city.width) >> 1;
			city.y = (480 - city.height) >> 1;
			//city.y -= 20;
			citySpr = new Sprite();
			citySpr.addChild(city);
			this.addChild(citySpr);
			
			motoGlowImage = new Image(_ta.getTexture("lightglow.png"));
			//motoGlowImage.scaleX = 0.75;
			motoGlowImage.x = (640 - motoGlowImage.width) >> 1;
			motoGlowImage.y = 480-motoGlowImage.height;
			
			motoGlowSpr = new Sprite();
			motoGlowSpr.addChild(motoGlowImage);
			this.addChild(motoGlowSpr);	
			
			
			dirtSpr = new Sprite();
			dirtSpr.blendMode = "multiply";
			dirtSpr.x = 640 >> 1;
			this.addChild(dirtSpr);
			
			(dirtSpr2) = new Sprite();
			//dirtSpr.x = 640 >> 1;
			dirtSpr.addChild(dirtSpr2);
			
			dirtImage2 = new Image(_ta.getTexture("dirt0.png"));
			dirtImage2.pivotX = dirtImage2.width >> 1;
			//dirtImage2.x = -640 >> 1;
			dirtImage2.y = 480-dirtImage2.height;
			dirtImage2.alpha = 0.35;
			dirtSpr2.addChild(dirtImage2);
			
			dirtImage = new Image(_ta.getTexture("dirt0.png"));
			dirtImage.pivotX = dirtImage.width >> 1;
			//dirtImage.x = -640 >> 1;
			dirtImage.y = 480-dirtImage.height;
			dirtImage.alpha = 0.35;
			dirtSpr2.addChild(dirtImage);
			
			roadBarsPM = new ParticleManager(RoadParticle);
			this.addChild(roadBarsPM.view);
			
			
			bd = new BitmapData(bdXmax, bdXmax);
			bd.perlinNoise(32, 32, 7, Math.random() * 1024, false, true,7,false);
			//var bit:Bitmap = new Bitmap(bd);
			//Starling.current.nativeOverlay.addChild(bit)
			
			vigneL0 = new Image(_ta.getTexture("vignetB0.png"))
			this.addChild(vigneL0);			
			vigneL1 = new Image(_ta.getTexture("vignetA0.png"))
			this.addChild(vigneL1);			
			
			vigneR0 = new Image(_ta.getTexture("vignetB1.png"))
			vigneR0.pivotX = vigneR0.width;
			vigneR0.x = 640;
			this.addChild(vigneR0);			
			vigneR1 = new Image(_ta.getTexture("vignetA1.png"))
			vigneR1.pivotX = vigneR1.width;
			vigneR1.x = 640;
			this.addChild(vigneR1);			

			lampsPM = new ParticleManager(LampParticle);
			lampsPM.generationInterval = 0.4;
			lampsPM.isLamp = true;
			this.addChild(lampsPM.view);
			
			enemyManager = new EnemyManager();
			this.addChild(enemyManager.view);
			
			hitLeft = new Hit("hitLeft.png");
			addChild(hitLeft);
			hitRight = new Hit("hitRight.png");
			hitRight.x = 640 - hitRight.width;
			addChild(hitRight);
			
			clicktofocus = new Clicktofocus();
			clicktofocus.visible = false;
			clicktofocus.x = 420;
			clicktofocus.y = 100;
			addChild(clicktofocus);
		}
		
		private function onEnterFrame(event:EnterFrameEvent, dt:Number):void 
		{
			InputModel.update();
			if (InputModel.getKeyState(InputModel.SPACE)==InputModel.KEY_JUST_PRESSED)
			{
				paused = !paused;
			}
			if (paused) return;
			
			if (dt > 1.0 / 20) dt = 1.0 / 20;
			
			bdX += 200*dt;
			if (bdX > bdXmax)
			{
				bdX = 0;
				bdY++;
			}
			if (bdY > bdXmax)
			{
				bdY = 0;
			}
			
			var frac:Number = (bd.getPixel(bdX, bdY) & 0xff) / 255;
			var fracX:Number = ((bd.getPixel(bdX, bdY)>> 16) & 0xff) / 255;
			var fracD:Number = ((bd.getPixel(bdX, bdY) >> 8) & 0xff) / 255;
			
			keyOffset = 0;
		
			
			if (InputModel.goRight())
			{
				keyOffset = 1;
				//if (keyOffset > 1) keyOffset = 1;
			}
			if (InputModel.goLeft())
			{
				keyOffset = -1;
				//if (keyOffset < -1) keyOffset = -1;
			}
			if (InputModel.mouseIs==false)
			{
				keyOffset = 0;
			}
			driverOffset += (keyOffset - driverOffset) * dt*4;
			
			citySpr.x = driverOffset * -5;
			roadBarsPM.view.x = driverOffset * -5;
			lampsPM.view.x = driverOffset * -5;
			enemyManager.view.x = driverOffset * -5;
			
			if (collideForceY > 0)
			{
				collideForceY -= dt;
			}
			else
			{
				collideForceY = 0;
			}
			
			motoGlowSpr.x = fracX* 30-15 + driverOffset*100;
			//motoGlowSpr.x = Math.random() * 10;
			motoGlowSpr.y = frac * 15 + collideForceY * 10;
			//motoGlowSpr.alpha = 1 - collideForceY/collideForceYMax;
			
			dirtSpr.y = fracD* 30;
			dirtSpr.alpha = 1 - (fracD) * 0.7;
			if (fracD>0.5)
			{
				dirtSpr2.scaleX = -1;
			}
			else
			{
				dirtSpr2.scaleX = 1;
			}			
			if (frac>0.5)
			{
				dirtImage2.visible = false;
			}
			else
			{
				dirtImage2.visible = true;
			}
			
			vigneL0.x = frac * -20-66;
			vigneL1.alpha = fracX;
			vigneL1.x = fracX*-50-66;
			vigneL1.alpha = frac;
			
			vigneR0.x = 640+fracD * 20+66;
			vigneR1.alpha = fracX;
			vigneR1.x = 640+fracX*50+66;
			vigneR1.alpha = fracD;
			
			roadBarsPM.update(dt)
			lampsPM.update(dt)
			enemyManager.update(dt)
			
			hitLeft.update(dt);
			hitRight.update(dt);
			
			if (InputModel.mouseIs == false)
			{
			clicktofocus.y = 100+fracX*5;
			clicktofocus.x = 420+fracD*5;
			clicktofocus.alpha = 1-fracX*0.3;

				enemyManager.skip = true;
				clicktofocus.visible = true;
				return;
			}
			else
			{
				enemyManager.skip = false;
				clicktofocus.visible = false;
			}
			
			
			tEnemy = null;
			tEnemy = enemyManager.collide(keyOffset);
			if (tEnemy!=null)
			{
				collideForceY = collideForceYMax;
				if (tEnemy.side == -1)
				{
					hitLeft.hit();
				}
				else
				{
					hitRight.hit();
				}
			}
		}
		
		public static function getFrac(x:int, y:int):Number
		{
			return (bd.getPixel(x, y) & 0xff) / 255;
		}
	}
	
}