/**
 * ----------------------------------------------------------------
 * Copyright (C) 2012 dx0ne
 * ----------------------------------------------------------------
 *
 * File:		Hit.as
 * Info:		
 * Package		 
 *
 * @author		dx0ne <dx0ne@laislacorporation.com>
 */
package  
{
	import starling.display.DisplayObjectContainer;
	import starling.display.Image;

	public class Hit extends DisplayObjectContainer
	{
		private var bdX:int = 0;
		private var bdY:int = 0;
		protected var lifeTime:Number = 1.;
		protected var currentTime:Number = 0;
		protected var timeFactor:Number=0;
		protected var isAlive:Boolean = false;
		
		private var img:Image;
		
		public function Hit(textureName:String) 
		{
			this.alpha = 0;
			img = new Image(AssetsGenerator.getTexture(textureName, AssetsGenerator.defaultAtlas));
			addChild(img);
		}
		
		public function update(dt:Number):void
		{
			if (!isAlive) return;
			
			bdX += 300*dt;
			if (bdX > Game.bdXmax)
			{
				bdX = 0;
				bdY++;
			}
			if (bdY > Game.bdXmax)
			{
				bdY = 0;
			}
			img.alpha = 1 - 0.7 * Game.getFrac(bdX, bdY);
			
			currentTime-= dt;
			if (currentTime < 0)
			{
				currentTime = 0;
				isAlive = false;
			}
			timeFactor = currentTime / lifeTime;
			this.alpha = timeFactor;
		}
		
		public function hit():void
		{
			isAlive = true;
			currentTime = lifeTime;
		}
	}

}