﻿/**
 * ...
 * @author dx0ne
 */
package  
{
	import flash.display.Stage;
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.ui.Keyboard;
	
	public class InputModel extends EventDispatcher
	{
		private static var keys:Vector.<int>;
		private static var stage:Stage;
		
		public static const W:int = 87;
		public static const S:int = 83;
		public static const A:int = 65;
		public static const D:int = 68;
		public static const I:int = 73;
		public static const P:int = 80;
		public static const R:int = 82;
		public static const SPACE:int = 32;
		public static const CTRL:int = 17;
		public static const SHIFT:int = 16;

		public static const KEY_JUST_RELEASED:int = -1;
		public static const KEY_IDLE:int = 0;
		public static const KEY_JUST_PRESSED:int = 2;		
		
		public static var mousePosition:Point;
		public static var mouseX:Number;
		public static var mouseY:Number;
		
		public static var LMB:int = 0;
		public static var RMB:int = 0;
		
		public static var keyString:String = "";
		public static var lastChar:String = "";
		public static var mouseIs:Boolean= false;
		
		public function InputModel() 
		{
		}
		
		public static function prepare(_stage:Stage):void
		{
			stage = _stage;
			
			initKeys();
			
			mousePosition = new Point();
			
			if (_stage != null)
			{
				stage.addEventListener(MouseEvent.MOUSE_DOWN, InputModel.leftMouseDownHandler);
				stage.addEventListener(MouseEvent.MOUSE_UP, InputModel.leftMouseUpHandler);
				stage.addEventListener(MouseEvent.RIGHT_MOUSE_DOWN, InputModel.rightMouseDownHandler);
				stage.addEventListener(MouseEvent.RIGHT_MOUSE_UP, InputModel.rightMouseUpHandler);
				stage.addEventListener(KeyboardEvent.KEY_DOWN, InputModel.keyDownHandler);
				stage.addEventListener(KeyboardEvent.KEY_UP, InputModel.keyUpHandler);
				stage.addEventListener(Event.DEACTIVATE, InputModel.mouseLeaveHandler);
				stage.addEventListener(Event.MOUSE_LEAVE, InputModel.mouseLeaveHandler);
			}
		}
		
		private static function mouseLeaveHandler(event:Event):void 
		{
			//InputModel.clearKeys();
			mouseIs = false;
		}
		
		private static function rightMouseUpHandler(e:MouseEvent):void 
		{
			RMB = -2;
		}
		
		private static function rightMouseDownHandler(e:MouseEvent):void 
		{
			RMB = Math.max(RMB, 1);;
			mouseIs = true;
		}
		
		private static function leftMouseUpHandler(e:MouseEvent):void 
		{
			LMB = -2;
		}
		
		private static function leftMouseDownHandler(e:MouseEvent):void 
		{
			LMB = Math.max(LMB, 1);;
			mouseIs = true;
		}
		
		public static function update():void
		{
			for (var i:int = 0; i < 256; i++){
				if (keys[i] != 0)
				{
					++keys[i];
				}
			}
			if (LMB != 0)
			{
				++LMB;
			}			
			if (RMB != 0)
			{
				++RMB;
			}
			if (stage)
			{
				mouseX = stage.mouseX;
				mouseY = stage.mouseY;
				mousePosition.x = mouseX;
				mousePosition.y = mouseY;
			}
		}
		
		public static function getKeyState(i:int):int
		{
			return keys[i];
		}

		private static function initKeys():void
		{
			keys = new Vector.<int>(256);
			
			for (var i:int = 0; i < 256;++i)
			{
				keys[i]=int(0);
			}
		}
		
		private static function clearKeys():void
		{
			for (var i:int = 0; i < 256;++i)
			{
				keys[i]=int(0);
			}
		}

		private static function keyDownHandler(e:KeyboardEvent):void
		{
			keys[e.keyCode] = 1;// Math.max(keys[e.keyCode], 1);
		}
		
		private static function keyUpHandler(e:KeyboardEvent):void
		{
			keys[e.keyCode] = -2;
		}		
		
		public static function goLeft():Boolean
		{
			if (getKeyState(InputModel.A) >= InputModel.KEY_JUST_PRESSED) return true;
			if (getKeyState(Keyboard.LEFT) >= InputModel.KEY_JUST_PRESSED) return true;
			return false;
		}
		
		public static function goRight():Boolean
		{
			if (getKeyState(InputModel.D) >= InputModel.KEY_JUST_PRESSED) return true;
			if (getKeyState(Keyboard.RIGHT) >= InputModel.KEY_JUST_PRESSED) return true;
			return false;
		}
		
		public static function goUp():Boolean
		{
			if (getKeyState(InputModel.W) >= InputModel.KEY_JUST_PRESSED) return true;
			if (getKeyState(Keyboard.UP) >= InputModel.KEY_JUST_PRESSED) return true;
			return false;
		}
		
		public static function goDown():Boolean
		{
			if (getKeyState(InputModel.S) >= InputModel.KEY_JUST_PRESSED) return true;
			if (getKeyState(Keyboard.DOWN) >= InputModel.KEY_JUST_PRESSED) return true;
			return false;
		}
	}
}
