/**
 * ----------------------------------------------------------------
 * Copyright (C) 2012 dx0ne
 * ----------------------------------------------------------------
 *
 * File:		LampParticle.as
 * Info:		
 * Package		 
 *
 * @author		dx0ne <dx0ne@laislacorporation.com>
 */
package  
{
	import starling.display.DisplayObjectContainer
	import starling.display.Image;
	import starling.display.Sprite;
	import starling.utils.deg2rad;
	
	public class LampParticle extends Particle
	{
		private var offsetX:Number = 10;
		private var offsetRot:Number = 17;
		public function LampParticle() 
		{
			spr = new Sprite();
			addChild(spr);
			
/*			img = new Image(AssetsGenerator.getTexture("lamp.png", AssetsGenerator.defaultAtlas));
			img.alpha = 0.5;
			img.x = -20;
			img.pivotX = img.width >> 1;
			img.pivotY = 0;
			spr.addChild(img);*/

			img = new Image(AssetsGenerator.getTexture("lamp.png", AssetsGenerator.defaultAtlas));
			img.pivotX = img.width >> 1;
			img.pivotY = 0;
			//img.scaleX = img.scaleY = 1.5;
			spr.addChild(img);
		}
		
		override public function init():void
		{
			currentTime = 0;
			lifeTime = 1.5;
			isAlive = true;
			diffX = 300;
			diffY = -170;
			startY = 240 + 20;
			startX = 320+offsetX;
			this.x = startX;
			this.y = startY;
			this.scaleX = this.scaleY = startScale;
			spr.scaleX = 1;
			this.visible = true;
			diffScale = 1.5;
			spr.rotation = -deg2rad(offsetRot);
		}
		
		override public function update(dt:Number):void
		{
			currentTime += dt;
			timeFactor = currentTime / lifeTime;
			if (timeFactor > 1)
			{
				timeFactor = 1;
			}
			this.x = easeInQuad(currentTime, startX, diffX, lifeTime);
			this.y = easeInQuad(currentTime, startY, diffY, lifeTime);
			this.scaleX = this.scaleY = noEasing(currentTime, 0.1, diffScale, lifeTime);
			
			if (timeFactor >= 1)			
				{
					die();
				}
		}
		
		public function lampInit(reverse:Boolean = false):void
		{
			if (reverse)
			{
				diffX *= -1;
				spr.scaleX = -1;
				spr.rotation = deg2rad(offsetRot);
				startX = 320 - offsetX;
				this.x = startX;
			}
		}
	}
}