/**
 * ----------------------------------------------------------------
 * Copyright (C) 2012 dx0ne
 * ----------------------------------------------------------------
 *
 * File:		Particle.as
 * Info:		
 * Package		 
 *
 * @author		dx0ne <dx0ne@laislacorporation.com>
 */
package  
{
	import starling.display.DisplayObjectContainer;
	import starling.display.Image;
	import starling.display.Sprite;
	
	public class Particle  extends DisplayObjectContainer
	{
		protected var spr:Sprite;
		protected var img:Image;
		
		public var isAlive:Boolean = false;		
		
		protected var startRotation:Number = 0;
		protected var rotationDiff:Number = 0;
		protected var startX:Number = 640 >> 1;
		protected var startY:Number = 240+30;
		protected var diffX:Number = 0;
		protected var diffY:Number = 240-50;
		protected var startScale:Number = 0;
		protected var diffScale:Number = 1.3;
		
		
		protected var lifeTime:Number = 1.5;
		protected var currentTime:Number = 0;
		
		protected var timeFactor:Number;
		
		public function Particle () 
		{
			this.visible = false;
		}
		
		public function init():void
		{
			diffX = 320;
			currentTime = 0;
			isAlive = true;
			this.x = startX;
			this.y = startY;
			this.scaleX = this.scaleY = startScale;
			this.visible = true;
		}
		
		public function update(dt:Number):void
		{
			currentTime += dt;
			timeFactor = currentTime / lifeTime;
			if (timeFactor > 1)
			{
				timeFactor = 1;
			}
			this.x = startX + diffX * timeFactor;
			this.y = easeInQuantic(currentTime, startY, diffY, lifeTime);
			this.scaleX = this.scaleY = easeInQuantic(currentTime, 0.01, diffScale, lifeTime);
			
			if (timeFactor >= 1)			
				{
					die();
				}
		}
		protected function noEasing(t:Number, b:Number, c:Number, d:Number):Number {
			return c * t / d + b;
		}
		
		protected function die():void
		{
			isAlive = false;
			visible = false;
		}
		
		protected function easeInQuantic(t:Number, b:Number, c:Number, d:Number):Number {
			var ts:Number=(t/=d)*t;
			var tc:Number=ts*t;
			return b+c*(tc*ts);
		}
		
		protected function easeInQuad(t:Number, b:Number, c:Number, d:Number):Number {
			var ts:Number=(t/=d)*t;
			return b+c*(ts);
		}
		protected function easeInOutQuantic(t:Number, b:Number, c:Number, d:Number):Number {
			var ts:Number=(t/=d)*t;
			var tc:Number=ts*t;
			return b+c*(6*tc*ts + -15*ts*ts + 10*tc);
		}
		
protected function easeOutQuantic(t:Number, b:Number, c:Number, d:Number):Number {
	var ts:Number=(t/=d)*t;
	var tc:Number=ts*t;
	return b+c*(tc*ts + -5*ts*ts + 10*tc + -10*ts + 5*t);
}		
protected function easeOutQubic(t:Number, b:Number, c:Number, d:Number):Number {
	var ts:Number=(t/=d)*t;
	var tc:Number=ts*t;
	return b+c*(tc + -3*ts + 3*t);
}
	}

}