/**
 * ----------------------------------------------------------------
 * Copyright (C) 2012 dx0ne
 * ----------------------------------------------------------------
 *
 * File:		ParticleManager.as
 * Info:		
 * Package		 
 *
 * @author		dx0ne <dx0ne@laislacorporation.com>
 */
package  
{
	import starling.display.Sprite;

	public class ParticleManager 
	{
		public var view:Sprite;
		
		private var particles:Vector.<Particle>;
		private var MAX_PARTICLES:int = 50;
		private var i:int;
		private var tP:Particle;
		
		public var generationInterval:Number = 0.30;
		private var lastGenerated:Number=0;
		
		public var isLamp:Boolean = false;
		
		public function ParticleManager(paricleClass:Class) 
		{
			view = new Sprite();
			
			particles = new Vector.<Particle>;

			for (i = 0; i < MAX_PARTICLES; i++ )
			{
				tP = new paricleClass();
				particles.push(tP);
				view.addChild(tP);
			}
		}
		
		public function update(dt:Number):void
		{
			lastGenerated += dt;
			if (lastGenerated >= generationInterval)
			{
				lastGenerated -= generationInterval;
				generateParticle();
				if (isLamp)
				{
					tP = generateParticle();
					if(tP)
						{
							(tP as LampParticle).lampInit(true);
						}
				}
			}
			var i:int=0;
			for (i = 0; i < MAX_PARTICLES; i++ )
			{
				tP = particles[i];
				if (!tP.isAlive) continue;
				
				tP.update(dt);
			}
		}
		
		private function generateParticle():Particle
		{
			tP = findFreeParticle();
			if (tP == null) return null;
			
			tP.init();
			return tP;
		}
		private function findFreeParticle():Particle
		{
			var i:int
			for (i = 0; i < MAX_PARTICLES; i++ )
			{
				tP = particles[i];
				if (tP.isAlive==false) return tP;
			}
			
			return null;
		}
	}

}